#include <cstdio>
#include "httpfun.hh"

const std::string htmlencode(const std::string& s)
{
    std::string result;
    for(std::string::const_iterator i = s.begin(); i != s.end(); ++i)
    {
        if(*i == '&')
            result += "&amp;";
        else if(*i == '<')
            result += "&lt;";
        else if(*i == '"')
            result += "&quot;";
        else result += *i;
    }
    return result;
}

const std::string urlencode(const std::string& s)
{
    std::string result;
    for(std::string::const_iterator i = s.begin(); i != s.end(); ++i)
    {
        if((*i >= 48 && *i <= 57)
        || (*i >= 65 && *i <= 90)
        || (*i >= 97 && *i <= 122)
        || (*i == 46))
            result += *i;
        else
        {
            char Buf[4];
            std::sprintf(Buf, "%02X", *i);
            result += Buf;
        }
    }
    return result;
}

const std::string urldecode(const std::string& input)
{
    std::string result;
    for(unsigned a=0; a<input.size(); ++a)
        if(input[a] == '+')
            result += ' ';
        else if(input[a] == '%')
        {
            unsigned c = 0;
            std::sscanf(input.c_str()+a+1, "%2X", &c);
            result += (char)c;
            a += 2;
        }
        else result += input[a];
    return result;
}
